// ●リスト3::ES6のクラス定義とインスタンス生成
// クラスの定義
class Person {
  // コンストラクタ
  constructor(name) {
    // プロパティ
    this.name = name;
  }

  // インスタンスメソッド
  greet() {
    console.log("Hello, I'm " + this.name);
  }

  // スタティックメソッド
  static create(name) {
    return new Person(name);
  }
}

// インスタンスの生成
var bob = new Person("Bob");
bob.greet();
// "Hello, I'm Bob"

// スタティックメソッドの呼び出し
var john = Person.create("John");
