// ●リスト1::ES6のコード例
// モジュールのインポート
import $ from "jquery";

// クラス定義
class Counter {
  // デフォルトパラメータ
  constructor(selector = "button") {
    this.count = 0;
    var elements = document.querySelectorAll(selector);
    // ブロックスコープ（let）、イテレータ
    for (let el of elements) {
      // アロー関数
      $(el).on("click", () => this.count++);
    }
  }
  output() {
    // テンプレートリテラル
    console.log(`count: ${this.count}`);
  }
}

// モジュールエクスポート
export default Counter;
