// ●リスト5::クラスの継承
// クラスの継承
class Author extends Person {
  constructor(name, book) {
    // (d1)親クラスのコンストラクタ呼び出し
    super(name);
    this.book = book;
  }

  // インスタンスメソッドのオーバーライド
  greet() {
    // (d2)親クラスのメソッド呼び出し
    super.greet();
    console.log("I wrote " + this.book);
  }

  // スタティックメソッドのオーバーライド
  static create(name, book) {
    return new Author(name, book);
  }
}

var author = new Author("Gillian Flynn", "Gone Girl");
author.greet();
// "Hello, I'm Gillian Flynn"
// "I wrote Gone Girl"
