// ●リスト9::yieldに値を渡す
// ロギング用関数
function msg(str) {
  console.log("msg:", str);
  return str;
}
function *generator2() {
  console.log("start")
  // (d1)ret1はnext()から値を受け取る
  var ret1 = yield msg("yield 1");
  console.log("ret1:", ret1);
  var ret2 = yield msg("yield 2");
  console.log("ret2:", ret2);
  return "end";
}
var g = generator2();
// (d2)最初のyieldまで進める
var next1 = g.next();
// "start"
// "msg:" "yield 1"
console.log(next1);
// {value: "yield 1", done: false}
// (d3)yieldに値を渡す
var next2 = g.next("next 1");
// "ret1:" "next 1"
// "msg:" "yield 2"
console.log(next2);
// {value: "yield 2", done: false}
var next3 = g.next("next 2");
// "ret2:" "next 2"
console.log(next3);
// {value: "end", done: true}
